∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘

> {-# LANGUAGE UnicodeSyntax #-}
> {-# OPTIONS_GHC -Wall -Wcompat -Wnoncanonical-monad-instances -Wnoncanonical-monadfail-instances
>                 -fno-warn-name-shadowing -fno-warn-missing-signatures -fno-warn-missing-methods
>                 -fno-warn-redundant-constraints -fno-warn-type-defaults -fno-warn-unused-imports #-}
>
> import Control.Exception (Exception, catch, throw)
> import Data.Function (fix, on)

∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘



Хаскель
========


◊1.1 Реализуйте функцию, умножающую аргумент на три:

> mult3 :: Num a => a -> a
> mult3 x = (??)
>
> tests_1_1 = [ mult3 5 == 15
>             , mult3 0 == 0
>             ]

◊1.2 Реализуйте функцию, возвращающую модуль числа:

> absolute :: Integer -> Integer
> absolute x = (??)
>
> tests_1_2 = [ absolute 5 == 5
>             , absolute 0 == 0
>             , absolute (-2) == 2
>             ]

◊1.3★ В этой задаче вам предстоит реализовать функцию, которая принимает функцию
      с двумя параметрами и меняет их местами, то есть возвращает новую функцию,
      которая эти два аргумента принимает в обратном порядке.
      Но вместо того чтобы реализовывать это руками, найдите такую стандартную функцию
      и впишите сюда в качестве ответа. Для этого поймите, какой у неё должен быть тип
      и поищите этот тип в Hoogle или Hayoo.

> swapParams = (??)
>
> tests_1_3 = [ swapParams (+) 3 5 == 8
>             , swapParams div 2 8 == 4
>             , swapParams (,) 3 7 == (7, 3)
>             ]

◊1.4★★ Реализуйте оператор примитивной рекурсии для встроенных целых чисел,
       работающий в константной памяти.

> prim_rec :: a -> (Integer -> a -> a) -> Integer -> a
> prim_rec = (??)
>
> tests_1_4 = [ prim_rec 0 (const (+1)) 5 == 5
>             , prim_rec 1 (\m r -> r * (m + 1)) 5 == 120
>             , prim_rec True (\_ _ -> False) 5 == False
>             ]

◊1.5★ Вычислите сумму квадратов, существенно используя стандартный оператор `on`.

> sumSquares :: Num a => a -> a -> a
> sumSquares = (??)
>
> tests_1_5 = [ sumSquares 3 4 == 25
>             ]



◊3.1 Реализуйте функцию, вычисляющую элементы следующей рекуррентной последовательности:

       a_0 = 5
       a_1 = 7
       a_2 = 4
       ...
       a_n = 2 * a_{n-1} * (10 - a_{n-2} - a_{n-3})

> relationA :: (Integral n, Num a) => n -> a
> relationA n = (??)
>
> tests_3_1 = [ relationA 2  == 4
>             , relationA 5  == 1408
>             , relationA 10 == 433494050252848279417764731289600
>             ]

◊3.2★ Реализуйте функцию, вычисляющую элементы следующей рекуррентной последовательности:

        a_0 = 5
        a_1 = 7
        a_2 = 4
        ...
        a_n = 2 * a_{n-1} * (10 - a_{n-2} - a_{n-3})

> relationA' :: (Integral n, Num a) => n -> a
> relationA' = (??)
>
> tests_3_2 = [ relationA' 2  == 4
>             , relationA' 5  == 1408
>             , relationA' 10 == 433494050252848279417764731289600
>             , relationA' 35 `mod` 10^40 `div` 10^30 == 2673384873
>             ]


◊3.3★★ В принципе, никто не мешает взять отношение, которым задаются числа Фибоначчи,
       и продлить его на отрицательные индексы. Так и поступите.

> fib :: (Integral n, Num a) => n -> a
> fib = (??)
>
> tests_3_3 = [ fib 0      == 0
>             , fib 100    == 354224848179261915075
>             , fib (-150) == -9969216677189303386214405760200
>             ]



◊4.1 Реализуйте функцию:

> nTimes :: Integral n => (a -> a) -> n -> a -> a
> nTimes = (??)
>
> tests_4_1 = [ nTimes (+1) 3 4 == 7
>             , nTimes not 15211 True == False
>             ]

◊4.2★ Реализуйте функцию:

> while :: (a -> Bool) -> (a -> a) -> a -> a
> while = (??)
>
> tests_4_2 = [ while (const False) (+2) 3 == 3
>             , while (< 100) (*3) 1 == 243
>             ]

◊4.3★ Реализуйте функцию:

> while' :: (a -> Bool) -> (a -> a) -> a -> a
> while' = (??)
>
> tests_4_3 = [ while' (const False) (+2) 3 == 3
>             , while' (< 100) (*3) 1 == 81
>             ]

◊4.4★ Реализуйте функцию, которая берет функцию и оборачивает её таким
      образом, чтобы возвращался модуль результата исходной функции.

> absolutised :: (a -> Integer) -> (a -> Integer)
> absolutised = (??)
>
> tests_4_4 = [ (absolutised succ)    5  == 6
>             , (absolutised succ)  (-5) == 4
>             ]



◊5.1★ Существенно используя оператор `fix`, вычислите двойной факториал
      (посмотрите в Википедии, если не уверены, что это) неотрицательного числа.

> doubleFact :: Integral n => n -> n
> doubleFact = (??)
>
> tests_5_1 = [ doubleFact 6 == 48
>             , doubleFact 7 == 105
>             ]


◊5.2★ Ну и закончим нашим любимым. Реализуйте функцию, которая принимает
      предикат на целых числах и возвращает _минимальное по модулю_ число, для которого
      переданный предикат выполняется:

> minp :: (Integer -> Bool) -> Integer
> minp = (??)
>
> tests_5_2 = [ minp (\_ -> True) == 0
>             , minp (> 8) == 9
>             , minp (< 0) == -1
>             ]



----------------------------------- ~fin~ -----------------------------------



Дальше нет ничего интересного.


\begin{code}

  data Skipped = Skipped
  instance Exception Skipped where
  instance Show Skipped where
    show Skipped = "skipped"

  (??){- Вместо этих вопросиков ничего писать не надо, их, очевидно, надо оставить на месте -} = throw Skipped

  ok_if_defined x = seq x True

  main :: IO ()
  main = sequence_ $ map (uncurry runTests) tests
    where
      tests = [ ("1.1", tests_1_1), ("1.2", tests_1_2), ("1.3", tests_1_3), ("1.4", tests_1_4), ("1.5", tests_1_5)
              , ("3.1", tests_3_1), ("3.2", tests_3_2), ("3.3", tests_3_3)
              , ("4.1", tests_4_1), ("4.2", tests_4_2), ("4.3", tests_4_3), ("4.4", tests_4_4)
              , ("5.1", tests_5_1), ("5.2", tests_5_2)
              ]

      runTests :: String -> [Bool] -> IO ()
      runTests n ts = do
        putStr $ "Running tests " ++ show n ++ "... "
        catch (putStr $ if (and ts) then "OK" else "FAIL") (\e -> putStr . show $ (e :: Skipped))
        putStrLn ""

\end{code}
